--TO DO LIST:
--1. Create Config Options table.
--4. Test the Faction/Capital check on an Alliance character.
--6. Configure the FIRST_RUN frame layout, as well as the Yes and No button functionality.
--	This will be done by manually writing frames...not using AceGUI.
--8. Write the Message Handler function.
--9. Import code for showing profiles page.
--10. Localize.
--11. Double check all code is documented.
--12. Implement play sound in SendBark.


--Register the addon with Ace3.
SK = LibStub("AceAddon-3.0"):NewAddon("SK", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0", "AceTimer-3.0");

---------------------------------------------
--                  Debug                  --
---------------------------------------------

local DEBUG_FRAME = tekDebug and tekDebug:GetFrame("Shop Keeper")
local DEBUGING = true
local sjoin = string.join

--Debug function.
local function D(...)
    if not DEBUGING then return end --If not debugging, then exit. Else, format the string and print it to the debug frame.
    local str = sjoin(", ",tostringall(...))
    str = str:gsub("([:=%[%]]),", "%1")
    DEBUG_FRAME:AddMessage("|cFFff6633SK Debug: |cFFE6E82B"..str)
end --End Debug function.


----------------------------------------------
--                  Config                  --
----------------------------------------------

--Declare the default character options.
D("Declaring default character options table.")
local DEFAULT_OPTIONS = {
	profile = {
		FIRST_RUN = true,
		BARKER = {
			ENABLED = true,
			BARK1_ENABLED = false,
			BARK2_ENABLED = false,
			BARK3_ENABLED = false,
			BARK4_ENABLED = false,
			BARK5_ENABLED = false,
			BARK6_ENABLED = false,
			BARK7_ENABLED = false,
			BARK8_ENABLED = false,
			BARK9_ENABLED = false,
			BARK10_ENABLED = false,
			BARK11_ENABLED = false,
			BARK12_ENABLED = false,
			BARK13_ENABLED = false,
			BARK14_ENABLED = false,
			BARK15_ENABLED = false,
			BARK16_ENABLED = false,
			BARK17_ENABLED = false,
			BARK18_ENABLED = false,
			BARK19_ENABLED = false,
			BARK20_ENABLED = false,
			BARK21_ENABLED = false,
			BARK22_ENABLED = false,
			BARK23_ENABLED = false,
			BARK24_ENABLED = false,
			BARK25_ENABLED = false,
			BARK1_TEXT = "Replace with your own advertisment.",
			BARK2_TEXT = "Replace with your own advertisment.",
			BARK3_TEXT = "Replace with your own advertisment.",
			BARK4_TEXT = "Replace with your own advertisment.",
			BARK5_TEXT = "Replace with your own advertisment.",
			BARK6_TEXT = "Replace with your own advertisment.",
			BARK7_TEXT = "Replace with your own advertisment.",
			BARK8_TEXT = "Replace with your own advertisment.",
			BARK9_TEXT = "Replace with your own advertisment.",
			BARK10_TEXT = "Replace with your own advertisment.",
			BARK11_TEXT = "Replace with your own advertisment.",
			BARK12_TEXT = "Replace with your own advertisment.",
			BARK13_TEXT = "Replace with your own advertisment.",
			BARK14_TEXT = "Replace with your own advertisment.",
			BARK15_TEXT = "Replace with your own advertisment.",
			BARK16_TEXT = "Replace with your own advertisment.",
			BARK17_TEXT = "Replace with your own advertisment.",
			BARK18_TEXT = "Replace with your own advertisment.",
			BARK19_TEXT = "Replace with your own advertisment.",
			BARK20_TEXT = "Replace with your own advertisment.",
			BARK21_TEXT = "Replace with your own advertisment.",
			BARK22_TEXT = "Replace with your own advertisment.",
			BARK23_TEXT = "Replace with your own advertisment.",
			BARK24_TEXT = "Replace with your own advertisment.",
			BARK25_TEXT = "Replace with your own advertisment.",
			RANDOMIZE_BARKS = false,
			LAST_BARK_USED = 0,
			BARK_INTERVAL = 1,
			DEBUG_MODE = false,
			TIMER1_HANDLE = "NOT_INITIATED",
			NOTIFY_ON_BARK_SENT = true,
			PLAY_SOUND_ON_BARK_SENT = true,
		}
	}
}
--Define the configuration options for Shop Keeper.
--TO DO: WRITE A REAL OPTIONS TABLE!
D("Declaring AceConfig config table.")
local CONFIG_TABLE = {
	type='group',
	name = "Shop Keeper",
	desc = "Customer management and tradeskill barking.",
	icon = [[Interface\Addons\ShopKeeper\graphics\icon]],
	args = {
		Logo = {
			order = 2,
			type = "description",
			name = "|TInterface\\Addons\\ShopKeeper\\\images\\icon_small:32:32:320:0|t",
		},
		Barker = {
			order = 1,
			type = "group",
			name = "Barker",
			desc = "Barker Options",
			args = {
				Enabled = {
					order = 1,
					type = "toggle",
					name = "Enabled",
					desc = "Use this to toggle the barker on and off. Note: Barker can be on, but won't bark unless you're in a capital city.",
					get = function(info) return SK.db.profile.BARKER.ENABLED end,
					set = function(info,val) SK.db.profile.BARKER.ENABLED = val end,
        		},
        		DescriptionText = {
        					order = 2,
        					type = "description",
        					name = "Use this page to define how long between each profession bark, in minutes. Minimum time between barks is 1 minute, and the maximum is 60. You can use intervals of half minutes.|n|n",
        					},
        		BarkInterval = {
        			order = 3,
        			type = "range",
        			name = "Bark Interval",
        			desc = "Set the intervals between each bark.",
        			min = 1,
					max = 60,
					step = .5,
					get = function(info) return SK.db.profile.BARKER.BARK_INTERVAL end,
					set = function(info,val) SK.db.profile.BARKER.BARK_INTERVAL = val end,
					}
				}
			}
		}
	}

--Runs when ShopKeeper is initialized. Used to "initialize" the addon.
function SK:OnInitialize()
    D("Begin OnInitialize")

    D("Connecting to/creating AceDB saved variables database.")
	SK.db = LibStub("AceDB-3.0"):New("SKDB",DEFAULT_OPTIONS)
	SK.db.RegisterCallback(SK, "OnProfileChanged", "OnProfileChanged")
	SK.db.RegisterCallback(SK, "OnProfileCopied", "OnProfileChanged")
	SK.db.RegisterCallback(SK, "OnProfileReset", "OnProfileChanged")
    
	D("Registering the options table.")
	-- Register the option table
	local AceConfig = LibStub("AceConfig-3.0")
	AceConfig:RegisterOptionsTable("Shop Keeper", CONFIG_TABLE)
	
	D("Adding ShopKeeper to Blizzard's Interface menu.")
	-- Create the interface option panel
	local AceConfigDialog = LibStub("AceConfigDialog-3.0")
	local optionFrame = AceConfigDialog:AddToBlizOptions("Shop Keeper", "Shop Keeper")
	
	-- Register a chat commands "/sk", "/shop", and "/shopkeeper" to open the Configuration Panel.
	SK:RegisterChatCommand("sk", "HandleSKChatCommand")
	SK:RegisterChatCommand("shop", "HandleSKChatCommand")
	SK:RegisterChatCommand("shopkeeper", "HandleSKChatCommand")
	SK:RegisterChatCommand("barker", "HandleBarkerChatCommand")

  	D("Registering Shop Keeper for events.")
 	--self:RegisterEvent("ZONE_CHANGED_NEW_AREA","ChannelChangeHandler") --Makes ShopKeeper aware of when the user changes zones and runs the ZoneChangeHandler function when the zone is changed.
   	self:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE","ChannelChangeHandler")
   	self:RegisterEvent("CHAT_MSG_CHANNEL","ChatMessageHandler") --Makes ShopKeeper aware of when a chat message comes through the chat frame and runs ChatMessageHandler function when a message is received.
	
   	D("First run:",SK.db.profile.FIRST_RUN)
   	if SK.db.profile.FIRST_RUN == true then --If this is the first time the addon is run for this character, we need to ask the user if he/she wants to configure the addon.
   		
   		SK.db.profile.FIRST_RUN = false --Set the FIRST_RUN flag to false since the next time this code is run, it won't be the first time for this character.
   		
   		D("First run now equals",SK.db.profile.FIRST_RUN)
		
		local AceGUI = LibStub("AceGUI-3.0")
		local FIRST_RUN_FRAME = AceGUI:Create("Frame")
		FIRST_RUN_FRAME:SetTitle("Shop Keeper")
		FIRST_RUN_FRAME:SetCallback("OnClose", function(widget) AceGUI:Release(widget) end)
		FIRST_RUN_FRAME:SetLayout("Flow")
		
		local TEXT = AceGUI:Create("Label")
		TEXT:SetFont("Calibri",12)
		TEXT:SetText("Welcome! Thanks for installing Shop Keeper. Since this is your first run of the addon, would you like to take a second and configure your settings?")
		FIRST_RUN_FRAME:AddChild(TEXT)
		
		local YES_BUTTON = AceGUI:Create("Button")
		YES_BUTTON:SetText("Yes!")
		YES_BUTTON:SetWidth(200)
		YES_BUTTON:SetCallback("OnClick", function() InterfaceOptionsFrame_OpenToCategory(optionFrame) end)
		FIRST_RUN_FRAME:AddChild(YES_BUTTON)
		
		local NO_BUTTON = AceGUI:Create("Button")
		NO_BUTTON:SetText("No, thanks.")
		NO_BUTTON:SetWidth(200)
		NO_BUTTON:SetCallback("OnClick", function() FIRST_RUN_FRAME:Hide() end)

		
   	end --End First Run check.
   	
   	D("End OnInitialize")
   	
   	SK:ChannelChangeHandler()

end

----------------------------------------------
--              Core Functions              --
----------------------------------------------
--Function to handle /sk chat commands.
function SK:HandleSKChatCommand(CHAT_COMMAND)
	
	D("Being HandleChatCommand.")
	D("CHAT_COMMAND = "..CHAT_COMMAND)
	
	if not CHAT_COMMAND or CHAT_COMMAND:trim() == "" then --If chat command is blank, open the main options screen.
		D("Chat command blank, opening options dialog.")
		LibStub("AceConfigDialog-3.0"):Open("Shop Keeper")
	elseif CHAT_COMMAND == "help" then --If the user is requesting help, print out chat command reference.
		D("User requested help information for Shop Keeper. Printing out command line options.")
		SK:Print("Shop Keeper commands are as follows:")
		print("/sk, /shop, /shopkeeper - Opens configuration dialog.")
		print("/sk help - Prints this text.")
		print("/sk more options to follow...")
	elseif CHAT_COMMAND == "barker enabled" or CHAT_COMMAND == "barker toggle" or CHAT_COMMAND == "toggle barker" then --If the user is using the "toggle" commands for the barker, check barker status and toggle it to the opposite.
		if SK.db.profile.BARKER.ENABLED == true then --If barker is on, toggle it off.
			SK.db.profile.BARKER.ENABLED = false
			SK:CancelingTimer(SK.db.profile.BARKER.TIMER1_HANDLE,true)
			SK:Print("Barker toggled off.")
		else --Since the barker is off, turn it on.
			SK.db.profile.BARKER.ENABLED = true
			SK.db.profile.BARKER.TIMER1_HANDLE = SK:ScheduleRepeatingTimer("EventHandler", SK.db.profile.BARKER.BARK_INTERVAL * 60)
			SK:Print("Barker toggled on.")
		end --End Barker On/Off Check
	elseif CHAT_COMMAND == "barker on" then --If the user is specifically stating to turn the barker on, check that it isn't already on and turn it on.
		if SK.db.profile.BARKER.ENABLED == true then --Barker is already on. Let the user know.
			SK:Print("Error: Barker is already on!")
		else --Since the barker is off, turn it on.
			SK.db.profile.BARKER.ENABLED = true
			SK.db.profile.BARKER.TIMER1_HANDLE = SK:ScheduleRepeatingTimer("EventHandler", SK.db.profile.BARKER.BARK_INTERVAL * 60)
			SK:Print("Barker toggled on.")
		end --End Barker already on check.
	elseif CHAT_COMMAND == "barker off" then --If the user is specifically stating to turn the barker off, check it isn't already off and turn it off.
		if SK.db.profile.BARKER.ENABLED == true then --If the barker is on, turn it off.
			SK.db.profile.BARKER.ENABLED = false
			SK:CancelTimer(SK.db.profile.BARKER.TIMER1_HANDLE,true)
			SK:Print("Barker toggled off.")
		else --Barker is already on. Let the user know.
			SK:Print("Error: Barker is already off.")
		end --End Barker already off check.
	else --If we get to here, the user typed some other command related to SK, but not one that we need to handle ourselves. Let AceConfigCmd do the work because I'm lazy.
		LibStub("AceConfigCmd-3.0").HandleCommand(SK, "sk", "Shop Keeper", CHAT_COMMAND)
	end --End special type of command check.
end --End SK command handler.

--Function to handle /barker chat commands. Will not document this function since it is nearly identical to the above.
function SK:HandleBarkerChatCommand(CHAT_COMMAND)
	D("Being HandleChatCommand.")
	D("CHAT_COMMAND = "..CHAT_COMMAND)
  if not CHAT_COMMAND or CHAT_COMMAND:trim() == "" then
  	D("Chat command blank, opening options dialog.")
    LibStub("AceConfigDialog-3.0"):Open("Shop Keeper")
  elseif CHAT_COMMAND == "help" then
  	D("User requested help information for Shop Keeper. Printing out command line options.")
  	SK:Print("Shop Keeper commands are as follows:")
  	print("/sk, /shop, /shopkeeper - Opens configuration dialog.")
  	print("/sk help - Prints this text.")
  	print("/sk more options to follow...")
  elseif CHAT_COMMAND == "enable" or CHAT_COMMAND == "toggle" then
  	if SK.db.profile.BARKER.ENABLED == true then
  		SK.db.profile.BARKER.ENABLED = false
  		SK:CancelTimer(SK.db.profile.BARKER.TIMER1_HANDLE,true)
  		SK:Print("Barker toggled off.")
  	else
  		SK.db.profile.BARKER.ENABLED = true
  		SK.db.profile.BARKER.TIMER1_HANDLE = SK:ScheduleRepeatingTimer("EventHandler", SK.db.profile.BARKER.BARK_INTERVAL * 60)
  		SK:Print("Barker toggled on.")
  	end
  elseif CHAT_COMMAND == "on" then
	if SK.db.profile.BARKER.ENABLED == true then
  		SK:Print("Error: Barker is already on!")
  	else
  		SK.db.profile.BARKER.ENABLED = true
  		SK.db.profile.BARKER.TIMER1_HANDLE = SK:ScheduleRepeatingTimer("EventHandler", SK.db.profile.BARKER.BARK_INTERVAL * 60)
  		SK:Print("Barker toggled on.")
  	end
  elseif CHAT_COMMAND == "off" then
  	if SK.db.profile.BARKER.ENABLED == true then
  		SK.db.profile.BARKER.ENABLED = false
  		SK:CancelTimer(SK.db.profile.BARKER.TIMER1_HANDLE,true)
  		SK:Print("Barker toggled off.")
  	else
  		SK:Print("Error: Barker is already off.")
  	end
  else
    LibStub("AceConfigCmd-3.0").HandleCommand(SK, "sk", "Shop Keeper", CHAT_COMMAND)
  end
end

--Function to make the necessay changes to settings when the user selects a new profile.
function SK:OnProfileChanged(event, database, newProfileKey)
	
	D("Begin OnProfileChanged.")
	
	-- apply settings, update frame, etc
	
	D("End OnProfileChanged.")
	
end --End OnProfileChanged function.

function SK:ChannelChangeHandler()

	D("Begin ChannelChangeHandler")
	
-- 	if arg1 then D("Arg1 = "..arg1) else D("Arg1 IS NIL!") end
-- 	if arg2 then D("Arg2 = "..arg2) else D("Arg2 IS NIL!") end
-- 	if arg3 then D("Arg3 = "..arg3) else D("Arg3 IS NIL!") end
-- 	if arg4 then D("Arg4 = "..arg4) else D("Arg4 IS NIL!") end
-- 	if arg5 then D("Arg5 = "..arg5) else D("Arg5 IS NIL!") end
-- 	if arg6 then D("Arg6 = "..arg6) else D("Arg6 IS NIL!") end
-- 	if arg7 then D("Arg7 = "..arg7) else D("Arg7 IS NIL!") end
-- 	if arg8 then D("Arg8 = "..arg8) else D("Arg8 IS NIL!") end
-- 	if arg9 then D("Arg9 = "..arg9) else D("Arg9 IS NIL!") end
-- 	if arg10 then D("Arg10 = "..arg10) else D("Arg10 IS NIL!") end
-- 	if arg11 then D("Arg11 = "..arg11) else D("Arg11 IS NIL!") end
-- 	if arg12 then D("Arg12 = "..arg12) else D("Arg12 IS NIL!") end
-- 	if arg13 then D("Arg13 = "..arg13) else D("Arg13 IS NIL!") end
-- 	if arg14 then D("Arg14 = "..arg14) else D("Arg14 IS NIL!") end
-- 	if arg15 then D("Arg15 = "..arg15) else D("Arg15 IS NIL!") end
	
	if arg7 == 2 then --If player did something related to trade channel, then...
		
		D("Channel change relates to trade. Checking for join/suspend/leave.")
		if arg1 == "YOU_JOINED" then --If they joined the trade chanel, then check that the barker is enabled and schedule the barker.
			
			D("Trade channel joined. Checking to see if barker is enabled.")
			if SK.db.profile.BARKER.ENABLED == true then --If the barker is enabled, then..
				
				D("Barker is enabled. Scheduling repeating timer for EventHandler")
				SK.db.profile.BARKER.TIMER1_HANDLE = SK:ScheduleRepeatingTimer("EventHandler", SK.db.profile.BARKER.BARK_INTERVAL * 60)
				D("Repeating timer scheduled.")
				
			else --Barker isn't enabled.
		
				D("Barker is not enabled.") --The barker isn't enabled, so we'll send a debug message if debugging is enabled to let me know...
				SK:CancelTimer(SK.db.profile.BARKER.TIMER1_HANDLE,true)
			
			end --End Barker Enabled check.
	
		elseif arg1 == "YOU_LEFT" or arg1 == "SUSPENDED" then --Else if they left the trade channel with /leave trade or left the city, then cancel the barker.
			
			D("Left trade channel. Cancelling repeating timer.")
			SK:CancelTimer(SK.db.profile.BARKER.TIMER1_HANDLE,true)
			SK.db.profile.BARKER.TIMER1_HANDLE = "TIMER_CANCELLED"
			D("Repeating timer cancelled.")
			
		else --Throw a debug error since they did something with the trade channel that we aren't expecting.
		
			D("In ChannelChangeHandler, arg7 indicated a change in the trade channel, but arg1 didn't evaluate to YOU_LEFT or SUSPENDED. Why?")
			if arg1 then D("Arg1 = "..arg1) else D("Arg1 IS NIL!") end
		
		end --End trade channel change check.
		
		D("End check for trade join/suspend/left.")
		
	else --Player didn't do something with the trade channel so we'll ignore it...
		
		D("Channel event not useful to ShopKeeper. Ignoring.")
		
	end --End channel check.
	
	D("End ChannelChangeHandler")

end --ChannelChangeHandler()
	

--Mother function. 
function SK:EventHandler()
	
	D("Begin EventHandler. Going to zone check.")
	
	if SK:ZoneCheck() == true then --This is slightly redundant for the barker since we cannot be in trade channel without being in a capital city. We do it anyway just to be safe.
		
		SK:BeginBarking()
	
	end

end

--Function to check the user's zone is a capital city. Redundant in the barker, but for customer management, will be useful for the
--option of "accept customers outside of capital."
function SK:ZoneCheck()

	local CURRENT_ZONE = GetZoneText() --Get the current zone and set it equal to CURRENT_ZONE.
	
	D("CURRENT ZONE:",CURRENT_ZONE)
	
	local PLAYER_FACTION = UnitFactionGroup("player") --Get the player's faction and set it equal to PLAYER_FACTION.
	
	if CURRENT_ZONE == "Shattrath City" or CURRENT_ZONE == "Dalaran" then --It doesn't matter what faction the player is if they are in a neutral capital. Go Bark anyway...
		
		D("Player is in Neutral capital. Ignoring faction and returning true.")
		
		return true --Return true we are in an area we can bark.
		
	else --If the current zone isn't Shattrath or Dalaran, then check to see if the player is in a capital city appropriate to their faction.
		
		D("Player is not in a neutral city, checking for faction vs. location.")
		if PLAYER_FACTION == "Horde" then --If the player is Horde, then check for current zone to be Orgrimmar, Thunderbluff, The Undercity, or Silvermoon.
			
			D("Player is Horde; looking for Horde capitals.")
			if CURRENT_ZONE == "Orgrimmar" or CURRENT_ZONE == "Thunder Bluff" or CURRENT_ZONE == "Undercity" or CURRENT_ZONE == "Silvermoon City" then
			
				D("Found player to be in Horde capital. Returning true.")
				return true 
				
			else
				
				D("Player is not in a Horde capital. Return false.")
				return false
				
			end --End Horde Zone Check
			
		elseif PLAYER_FACTION == "Alliance" then --If the player is Alliance, then check for the current zone to be Stormwind, Ironforge, Darnassus, or The Exodar.
			
			D("Player is Alliance; looking for Alliance capitals.")
			if CURRENT_ZONE == "Stormwind City" or CURRENT_ZONE == "Ironforge" or CURRENT_ZONE == "Darnassus" or CURRENT_ZONE == "The Exodar" then
				
				D("Found player to be in Alliance capital. Returning true")
				return true
				
			else
				
				D("Player is not in an Alliance capital. Returning false.")
				return false
				
			end --End Alliance Zone Check
			
		else --Player faction didn't match Horde or Alliance...we're in trouble. Let the user know.
			
			Print("Error in Shop Keeper! Player faction didn't match Alliance OR Horde. How did we get here?")
			D("Error in ZoneChangeHandler. The player faction didn't match Horde or Alliance.")
			return false
			
		end -- End Faction Check
		
	end --End Neutral Capital Zone check.

end --End ZoneChangeHandler function.

--Function that handles chat messages, checking to see if it is a whisper that contains a tradeskill item link.
function SK:ChatMessageHandler()
	
	D("Begin ChatMessageHandler")

	D("End ChatMessageHandler")
	
end --End ChatMessageHandler function.

--Function that sets barking for tradeskills in motion.
function SK:BeginBarking()

	D("Begin BeginBarking. Going to CheckConfig.")
	
	if SK:CheckConfig() == true then --Check the user's configuration for any possible "logic" errors.
		
		D("Displaying warning message.")
		SK:Print("Unfortunately, you have all of the barkers disabled so I couldn't bark for you. This could be due to not configuring Shop Keeper if this is your first use of the addon. I have shut down the Barker for now so that you don't continue to get warnings like this. You'll need to enable at least one barker and then turn the bark back on.")
		
	else --Configuration came back "okay", continue with barking.
		
		--Get trade channel number so we can pass it to the SendBark() function.
		D("Getting trade channel number.")
		local TRADE_CHANNEL_NUMBER = GetChannelName("Trade - City")
		D("Trade channel = "..TRADE_CHANNEL_NUMBER)
		
		repeat --Run the following code until we get an other-than-false return from SelectBark().
			
			BARK_TEXT = SK:SelectBark() --Set return of SelectBark() == BARK_TEXT.
			
		until BARK_TEXT ~= false
		
		--If we are here, we now have an other-than-false statement from SelectBark().
		D("Selected Bark is "..BARK_TEXT)
		
		D("Time to replace wildcards.")
		
		--We now need to scan the bark for the tradeskill and city wildcards. We do this by going to MakeLinks(), passing it the bark.
		BARK_TEXT = SK:MakeLinks(BARK_TEXT)
		
		--Wildcards, if used, have now been replaced and we are ready to send the bark out.
		D("Wildcards replaced.")
		D("New BARK_TEXT: "..BARK_TEXT)
		
		--Send the bark to the SendBark() function, passing it the bark message and the trade channel.
		--Used a function for this just in case I might reuse the code in the function at a later date.
		SK:SendBark(TRADE_CHANNEL_NUMBER,BARK_TEXT)
		
	end
	
	D("End BeginBarking")
	
end --End Barker function.

--Function that checks to see if the user has possibly misconfigured the settings such that all 25 barks are disabled.
function SK:CheckConfig()
	
	D("Begin CheckConfig")
	--Check to see if all the barks are disabled. Without this check, we could have potentially run into an infinite loop in SelectBark().
	if SK.db.profile.BARKER.BARK1_ENABLED == false and SK.db.profile.BARKER.BARK2_ENABLED == false and SK.db.profile.BARKER.BARK3_ENABLED == false and SK.db.profile.BARKER.BARK4_ENABLED == false and SK.db.profile.BARKER.BARK5_ENABLED == false and SK.db.profile.BARKER.BARK6_ENABLED == false and SK.db.profile.BARKER.BARK7_ENABLED == false and SK.db.profile.BARKER.BARK8_ENABLED == false and SK.db.profile.BARKER.BARK9_ENABLED == false and SK.db.profile.BARKER.BARK10_ENABLED == false and SK.db.profile.BARKER.BARK11_ENABLED == false and SK.db.profile.BARKER.BARK12_ENABLED == false and SK.db.profile.BARKER.BARK13_ENABLED == false and SK.db.profile.BARKER.BARK14_ENABLED == false and SK.db.profile.BARKER.BARK15_ENABLED == false and SK.db.profile.BARKER.BARK16_ENABLED == false and SK.db.profile.BARKER.BARK17_ENABLED == false and SK.db.profile.BARKER.BARK18_ENABLED == false and SK.db.profile.BARKER.BARK19_ENABLED == false and SK.db.profile.BARKER.BARK20_ENABLED == false and SK.db.profile.BARKER.BARK21_ENABLED == false and SK.db.profile.BARKER.BARK22_ENABLED == false and SK.db.profile.BARKER.BARK23_ENABLED == false and SK.db.profile.BARKER.BARK24_ENABLED == false and SK.db.profile.BARKER.BARK25_ENABLED == false then
		
		D("All Barkers were found to be disabled during the check in CheckConfig. Turning off the barker and returning a true value for CheckConfig.")
		SK.db.profile.BARKER.ENABLED = false --Turn the barker off. User will have to manually turn the barker back on.
		
		return true --Return a true value. As in...we found an error. Might change this from "true" to some string value if we need to do more complicated validation later on.
		
	else --No error found.
		
		D("At least one bark was enabled. Returning a false value for CheckConfig. (This is good.)")
		return false --Return a false value. As in...no error found and we can proceed.
		
	end --End error checking.
	
	D("End CheckConfig")

end --End CheckConfig()

--Function to select which bark to send this time.
function SK:SelectBark()
	
	D("Begin SelectBark")
	
	if SK.db.profile.BARKER.RANDOMIZE_BARKS then --If the user has specified to bark randomly, then...
		
		D("User has selected random barks.")		
		--Generate a random number between 1 and 25.
		local RANDOM_NUMBER = math.random(25)
		
		D("Current random number generated is: "..RANDOM_NUMBER)
		
		--Check the random number (read: selected bark) against whether that bark is turn on.
		--If the bark is not enabled, return a false value.
		--If the bark is enabled, we will end up at the bottom of this long if-then statement at the else statement...
		if RANDOM_NUMBER == 1 and SK.db.profile.BARKER.BARK1_ENABLED == false then
			
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 2 and SK.db.profile.BARKER.BARK2_ENABLED == false then
			
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 3 and SK.db.profile.BARKER.BARK3_ENABLED == false then
			
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 4 and SK.db.profile.BARKER.BARK4_ENABLED == false then
			
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 5 and SK.db.profile.BARKER.BARK5_ENABLED == false then
			
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 6 and SK.db.profile.BARKER.BARK6_ENABLED == false then
			
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 7 and SK.db.profile.BARKER.BARK7_ENABLED == false then
			
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 8 and SK.db.profile.BARKER.BARK8_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 9 and SK.db.profile.BARKER.BARK9_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 10 and SK.db.profile.BARKER.BARK10_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 11 and SK.db.profile.BARKER.BARK11_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 12 and SK.db.profile.BARKER.BARK12_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 13 and SK.db.profile.BARKER.BARK13_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 14 and SK.db.profile.BARKER.BARK14_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 15 and SK.db.profile.BARKER.BARK15_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 16 and SK.db.profile.BARKER.BARK16_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 17 and SK.db.profile.BARKER.BARK17_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 18 and SK.db.profile.BARKER.BARK18_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 19 and SK.db.profile.BARKER.BARK19_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 20 and SK.db.profile.BARKER.BARK20_ENABLED == false then
		
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 21 and SK.db.profile.BARKER.BARK21_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 22 and SK.db.profile.BARKER.BARK22_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 23 and SK.db.profile.BARKER.BARK23_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 24 and SK.db.profile.BARKER.BARK24_ENABLED == false then
	
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		elseif RANDOM_NUMBER == 25 and SK.db.profile.BARKER.BARK25_ENABLED == false then
		
			D("RANDOM NUMBER matches an disabled barker. Returning false.")
			
			return false
			
		else --...where we now know that the selected bark is enabled and we can continue. We now need to return an other-than-false value, which will be the selected bark's text.
		
			D("RANDOM_NUMBER didn't match a disabled barker. We can continue.")
			D("Just need to determine which bark text to return.")
			
			--Figure out what the random number was, return the matching bark's text.
			if RANDOM_NUMBER == 1 then
			
				D("RANDOM_NUMBER == 1")
			
				return SK.db.profile.BARKER.BARK1_TEXT
			
			elseif RANDOM_NUMBER == 2 then
			
				D("RANDOM_NUMBER == 2")
			
				return SK.db.profile.BARKER.BARK2_TEXT
			
			elseif RANDOM_NUMBER == 3 then
			
				D("RANDOM_NUMBER == 3")
			
				return SK.db.profile.BARKER.BARK3_TEXT
			
			elseif RANDOM_NUMBER == 4 then
			
				D("RANDOM_NUMBER == 4")
			
				return SK.db.profile.BARKER.BARK4_TEXT
			
			elseif RANDOM_NUMBER == 5 then
			
				D("RANDOM_NUMBER == 5")
			
				return SK.db.profile.BARKER.BARK5_TEXT
			
			elseif RANDOM_NUMBER == 6 then
			
				D("RANDOM_NUMBER == 6")
			
				return SK.db.profile.BARKER.BARK6_TEXT
			
			elseif RANDOM_NUMBER == 7 then
			
				D("RANDOM_NUMBER == 7")
			
				return SK.db.profile.BARKER.BARK7_TEXT
			
			elseif RANDOM_NUMBER == 8 then
			
				D("RANDOM_NUMBER == 8")
			
				return SK.db.profile.BARKER.BARK8_TEXT
			
			elseif RANDOM_NUMBER == 9 then
			
				D("RANDOM_NUMBER == 9")
			
				return SK.db.profile.BARKER.BARK9_TEXT
			
			elseif RANDOM_NUMBER == 10 then
			
				D("RANDOM_NUMBER == 10")
			
				return SK.db.profile.BARKER.BARK10_TEXT
			
			elseif RANDOM_NUMBER == 11 then
			
				D("RANDOM_NUMBER == 11")
			
				return SK.db.profile.BARKER.BARK11_TEXT
			
			elseif RANDOM_NUMBER == 12 then
			
				D("RANDOM_NUMBER == 12")
			
				return SK.db.profile.BARKER.BARK12_TEXT
			
			elseif RANDOM_NUMBER == 13 then
			
				D("RANDOM_NUMBER == 13")
			
				return SK.db.profile.BARKER.BARK13_TEXT
			
			elseif RANDOM_NUMBER == 14 then
			
				D("RANDOM_NUMBER == 14")
			
				return SK.db.profile.BARKER.BARK14_TEXT
			
			elseif RANDOM_NUMBER == 15 then
			
				D("RANDOM_NUMBER == 15")
			
				return SK.db.profile.BARKER.BARK15_TEXT
			
			elseif RANDOM_NUMBER == 16 then
			
				D("RANDOM_NUMBER == 16")
			
				return SK.db.profile.BARKER.BARK16_TEXT
			
			elseif RANDOM_NUMBER == 17 then
			
				D("RANDOM_NUMBER == 17")
			
				return SK.db.profile.BARKER.BARK17_TEXT
			
			elseif RANDOM_NUMBER == 18 then
			
				D("RANDOM_NUMBER == 18")
			
				return SK.db.profile.BARKER.BARK18_TEXT
			
			elseif RANDOM_NUMBER == 19 then
			
				D("RANDOM_NUMBER == 19")
			
				return SK.db.profile.BARKER.BARK19_TEXT
			
			elseif RANDOM_NUMBER == 20 then
			
				D("RANDOM_NUMBER == 20")
			
				return SK.db.profile.BARKER.BARK20_TEXT
			
			elseif RANDOM_NUMBER == 21 then
			
				D("RANDOM_NUMBER == 21")
			
				return SK.db.profile.BARKER.BARK21_TEXT
			
			elseif RANDOM_NUMBER == 22 then
			
				D("RANDOM_NUMBER == 22")
			
				return SK.db.profile.BARKER.BARK22_TEXT
			
			elseif RANDOM_NUMBER == 23 then
			
				D("RANDOM_NUMBER == 23")
			
				return SK.db.profile.BARKER.BARK23_TEXT
			
			elseif RANDOM_NUMBER == 24 then
			
				D("RANDOM_NUMBER == 24")
			
				return SK.db.profile.BARKER.BARK24_TEXT
			
			elseif RANDOM_NUMBER == 25 then
			
				D("RANDOM_NUMBER == 25")
			
				return SK.db.profile.BARKER.BARK25_TEXT
				
			else
			
				D("Error in determining which bark matched the RANDOM_NUMBER. There is NO WAY we should have gotten here!!")
				
			end
		end
		
	else --User has decided not to randomize their barks. We'll just pick them in sequential order, as long as they are enabled.
		
		D("User selected sequential use of barks. Time to increment LAST_BARK_USED and grab new text.")
		
		if SK.db.profile.BARKER.LAST_BARK_USED == 0 or SK.db.profile.BARKER.LAST_BARK_USED == 25 then --If the last bark used is somehow set to 0 or the highest number bark, we need to reset the value to 1.
			
			D("SK.db.profile.BARKER.LAST_BARK_USED == 0 or 25; resetting to 1.")
			
			SK.db.profile.BARKER.LAST_BARK_USED = 1
			
			D("SK.db.profile.BARKER.LAST_BARK_USED now equal to "..SK.db.profile.BARKER.LAST_BARK_USED)
			
		else --Otherwise, we just increment the last bark used and use that bark.
			
			D("Old LAST_BARK_USED == "..SK.db.profile.BARKER.LAST_BARK_USED)
			
			SK.db.profile.BARKER.LAST_BARK_USED = SK.db.profile.BARKER.LAST_BARK_USED + 1
			
			D("New LAST_BARK_USED == "..SK.db.profile.BARKER.LAST_BARK_USED)
			
		end
		
		D("LAST_BARK_USED is now incremented. Grab check that the new value is a for a barker that is enabled.")
		
		--Now we check that the newly incremented last bark used value can match an enabled bark.
		--If not, return a false statement to the calling function, which will end up repeating this code until get get a positive match.
		if SK.db.profile.BARKER.LAST_BARK_USED == 1 and SK.db.profile.BARKER.BARK1_ENABLED == false then
			
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 2 and SK.db.profile.BARKER.BARK2_ENABLED == false then
			
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 3 and SK.db.profile.BARKER.BARK3_ENABLED == false then
			
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 4 and SK.db.profile.BARKER.BARK4_ENABLED == false then
			
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 5 and SK.db.profile.BARKER.BARK5_ENABLED == false then
			
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 6 and SK.db.profile.BARKER.BARK6_ENABLED == false then
			
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 7 and SK.db.profile.BARKER.BARK7_ENABLED == false then
			
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 8 and SK.db.profile.BARKER.BARK8_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 9 and SK.db.profile.BARKER.BARK9_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 10 and SK.db.profile.BARKER.BARK10_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 11 and SK.db.profile.BARKER.BARK11_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 12 and SK.db.profile.BARKER.BARK12_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 13 and SK.db.profile.BARKER.BARK13_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 14 and SK.db.profile.BARKER.BARK14_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 15 and SK.db.profile.BARKER.BARK15_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 16 and SK.db.profile.BARKER.BARK16_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 17 and SK.db.profile.BARKER.BARK17_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 18 and SK.db.profile.BARKER.BARK18_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 19 and SK.db.profile.BARKER.BARK19_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 20 and SK.db.profile.BARKER.BARK20_ENABLED == false then
		
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 21 and SK.db.profile.BARKER.BARK21_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 22 and SK.db.profile.BARKER.BARK22_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 23 and SK.db.profile.BARKER.BARK23_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 24 and SK.db.profile.BARKER.BARK24_ENABLED == false then
	
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		elseif SK.db.profile.BARKER.LAST_BARK_USED == 25 and SK.db.profile.BARKER.BARK25_ENABLED == false then
		
			D("LAST_BARK_USED matches an disabled barker. Returning false.")
			
			return false
			
		else --If we are here, we must have been able to match the new last bark used with a bark that is enabled. We just need to figure out which one it was and return that bark's text.
			
			D("Found a bark that was enabled for sequential method. It was number "..SK.db.profile.BARKER.LAST_BARK_USED)
			--Match the last bark used value up with a bark's text and return it.
			if SK.db.profile.BARKER.LAST_BARK_USED == 1 then
				
				D("Grabbing .BARKER.BARK1_TEXT: "..SK.db.profile.BARKER.BARK1_TEXT)
				return SK.db.profile.BARKER.BARK1_TEXT
				
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 2 then
			
				D("Grabbing .BARKER.BARK2_TEXT: "..SK.db.profile.BARKER.BARK2_TEXT)
				return SK.db.profile.BARKER.BARK2_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 3 then
			
				D("Grabbing .BARKER.BARK3_TEXT: "..SK.db.profile.BARKER.BARK3_TEXT)
				return SK.db.profile.BARKER.BARK3_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 4 then
			
				D("Grabbing .BARKER.BARK4_TEXT: "..SK.db.profile.BARKER.BARK4_TEXT)
				return SK.db.profile.BARKER.BARK4_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 5 then
			
				D("Grabbing .BARKER.BARK5_TEXT: "..SK.db.profile.BARKER.BARK5_TEXT)
				return SK.db.profile.BARKER.BARK5_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 6 then
			
				D("Grabbing .BARKER.BARK6_TEXT: "..SK.db.profile.BARKER.BARK6_TEXT)
				return SK.db.profile.BARKER.BARK6_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 7 then
			
				D("Grabbing .BARKER.BARK7_TEXT: "..SK.db.profile.BARKER.BARK7_TEXT)
				return SK.db.profile.BARKER.BARK7_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 8 then
			
				D("Grabbing .BARKER.BARK8_TEXT: "..SK.db.profile.BARKER.BARK8_TEXT)
				return SK.db.profile.BARKER.BARK8_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 9 then
			
				D("Grabbing .BARKER.BARK9_TEXT: "..SK.db.profile.BARKER.BARK9_TEXT)
				return SK.db.profile.BARKER.BARK9_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 10 then
			
				D("Grabbing .BARKER.BARK10_TEXT: "..SK.db.profile.BARKER.BARK10_TEXT)
				return SK.db.profile.BARKER.BARK10_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 11 then
			
				D("Grabbing .BARKER.BARK11_TEXT: "..SK.db.profile.BARKER.BARK11_TEXT)
				return SK.db.profile.BARKER.BARK11_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 12 then
			
				D("Grabbing .BARKER.BARK12_TEXT: "..SK.db.profile.BARKER.BARK12_TEXT)
				return SK.db.profile.BARKER.BARK12_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 13 then
			
				D("Grabbing .BARKER.BARK13_TEXT: "..SK.db.profile.BARKER.BARK13_TEXT)
				return SK.db.profile.BARKER.BARK13_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 14 then
			
				D("Grabbing .BARKER.BARK14_TEXT: "..SK.db.profile.BARKER.BARK14_TEXT)
				return SK.db.profile.BARKER.BARK14_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 15 then
			
				D("Grabbing .BARKER.BARK15_TEXT: "..SK.db.profile.BARKER.BARK15_TEXT)
				return SK.db.profile.BARKER.BARK15_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 16 then
			
				D("Grabbing .BARKER.BARK16_TEXT: "..SK.db.profile.BARKER.BARK16_TEXT)
				return SK.db.profile.BARKER.BARK16_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 17 then
			
				D("Grabbing .BARKER.BARK17_TEXT: "..SK.db.profile.BARKER.BARK17_TEXT)
				return SK.db.profile.BARKER.BARK17_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 18 then
			
				D("Grabbing .BARKER.BARK18_TEXT: "..SK.db.profile.BARKER.BARK18_TEXT)
				return SK.db.profile.BARKER.BARK18_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 19 then
			
				D("Grabbing .BARKER.BARK19_TEXT: "..SK.db.profile.BARKER.BARK19_TEXT)
				return SK.db.profile.BARKER.BARK19_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 20 then
			
				D("Grabbing .BARKER.BARK20_TEXT: "..SK.db.profile.BARKER.BARK20_TEXT)
				return SK.db.profile.BARKER.BARK20_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 21 then
			
				D("Grabbing .BARKER.BARK21_TEXT: "..SK.db.profile.BARKER.BARK21_TEXT)
				return SK.db.profile.BARKER.BARK21_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 22 then
			
				D("Grabbing .BARKER.BARK22_TEXT: "..SK.db.profile.BARKER.BARK22_TEXT)
				return SK.db.profile.BARKER.BARK22_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 23 then
			
				D("Grabbing .BARKER.BARK23_TEXT: "..SK.db.profile.BARKER.BARK23_TEXT)
				return SK.db.profile.BARKER.BARK23_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 24 then
			
				D("Grabbing .BARKER.BARK24_TEXT: "..SK.db.profile.BARKER.BARK24_TEXT)
				return SK.db.profile.BARKER.BARK24_TEXT
			
			elseif SK.db.profile.BARKER.LAST_BARK_USED == 25 then
			
				D("Grabbing .BARKER.BARK25_TEXT: "..SK.db.profile.BARKER.BARK25_TEXT)
				return SK.db.profile.BARKER.BARK25_TEXT
				
			else --Serious problem if we end up here. This is technically impossible.
			
				D("Error in trying to find a bark that matched vs the last bark used in the sequential method. There is no way we should have gotten here!!")
				
			end --End matchmaking if-then statement.
			
		end --End bark enabled vs new last used bark check.
	
	end --End random vs sequential check.
		
end --End SelectBark()

--Function to find keywords in barks and replace them with links.
function SK:MakeLinks(BARK)
	
	--Find all tradeskill wildcards and replace them with tradeskill links.
	if string.find(BARK,"<ALCHEMY>") then
		
		D("Found Alchemy as this bark's profession.")
		
		local LINK, TRADE_LINK = GetSpellLink("Alchemy")
	
		local CURRENT_ZONE = GetZoneText()
				
		BARK = string.gsub(BARK, '<ALCHEMY>', TRADE_LINK)
		BARK = string.gsub(BARK, '<CITY>', CURRENT_ZONE)
		
		return BARK
		
	elseif string.find(BARK,"<BLACKSMITHING>") then
		
		D("Found Blacksmith as this bark's profession.")
		
		local LINK, TRADE_LINK = GetSpellLink("Blacksmithing")
	
		local CURRENT_ZONE = GetZoneText()
				
		BARK = string.gsub(BARK, '<BLACKSMITHING>', TRADE_LINK)
		BARK = string.gsub(BARK, '<CITY>', CURRENT_ZONE)
		
		return BARK
		
	 elseif string.find(BARK,"<COOKING>") then
		
		D("Found Cooking as this bark's profession.")
		
		local LINK, TRADE_LINK = GetSpellLink("Cooking")
	
		local CURRENT_ZONE = GetZoneText()
				
		BARK = string.gsub(BARK, '<COOKING>', TRADE_LINK)
		BARK = string.gsub(BARK, '<CITY>', CURRENT_ZONE)
		
		return BARK
		
	elseif string.find(BARK,"<ENCHANTING>") then
		
		D("Found Enchanting as this bark's profession.")
		
		local LINK, TRADE_LINK = GetSpellLink("Enchanting")
	
		local CURRENT_ZONE = GetZoneText()
				
		BARK = string.gsub(BARK, '<ENCHANTING>', TRADE_LINK)
		BARK = string.gsub(BARK, '<CITY>', CURRENT_ZONE)
		
		return BARK
		
	elseif string.find(BARK,"<ENGINEERING>") then
		
		D("Found Engineering as this bark's profession.")
		
		local LINK, TRADE_LINK = GetSpellLink("Engineering")
	
		local CURRENT_ZONE = GetZoneText()
				
		BARK = string.gsub(BARK, '<ENGINEERING>', TRADE_LINK)
		BARK = string.gsub(BARK, '<CITY>', CURRENT_ZONE)
		
		return BARK
		
	elseif string.find(BARK,"<JEWELCRAFTING>") then
		
		D("Found Jewelcrafting as this bark's profession.")
		
		local LINK, TRADE_LINK = GetSpellLink("Jewelcrafting")
	
		local CURRENT_ZONE = GetZoneText()
				
		BARK = string.gsub(BARK, '<JEWELCRAFTING>', TRADE_LINK)
		BARK = string.gsub(BARK, '<CITY>', CURRENT_ZONE)
		
		return BARK
		
	elseif string.find(BARK,"<LEATHERWORKING>") then
		
		D("Found LEATHERWORKING as this bark's profession.")
		
		local LINK, TRADE_LINK = GetSpellLink("Leatherworking")
	
		local CURRENT_ZONE = GetZoneText()
				
		BARK = string.gsub(BARK, '<LEATHERWORKING>', TRADE_LINK)
		BARK = string.gsub(BARK, '<CITY>', CURRENT_ZONE)
		
		return BARK
		
	elseif string.find(BARK,"<LOCKPICKING>") then
		
		D("Found Lockpicking as this bark's profession.")
		
		local LINK, TRADE_LINK = GetSpellLink("Lockpicking")
	
		local CURRENT_ZONE = GetZoneText()
				
		BARK = string.gsub(BARK, '<LOCKPICKING>', TRADE_LINK)
		BARK = string.gsub(BARK, '<CITY>', CURRENT_ZONE)
		
		return BARK
		
	elseif string.find(BARK,"<TAILORING>") then
		
		D("Found Tailoring as this bark's profession.")
		
		local LINK, TRADE_LINK = GetSpellLink("Tailoring")
	
		local CURRENT_ZONE = GetZoneText()
				
		BARK = string.gsub(BARK, '<TAILORING>', TRADE_LINK)
		BARK = string.gsub(BARK, '<CITY>', CURRENT_ZONE)
		
		return BARK
		
	else --User didn't have any tradeskill wildcards in their bark. Just return what we got...
	
		return BARK
		
	end
	
end

--Function that actually sends the bark to trade.
function SK:SendBark(CHANNELID, TEXT)

	D("Begin SendBark")
	
	if SK.db.profile.BARKER.DEBUG_MODE then --If we have decided to "faux" bark this, just to see what it would have been.

		D("Successfully sending bark. Bark would have been:")
		D(TEXT.." Sent to channel "..CHANNELID)

		SK:Print("Successfully sending bark. Bark would have been:")
		SK:Print(TEXT)
		SK:Print("The bark would have been sent to channel "..CHANNELID..".")

	else --User wants bark actually sent.
	
		D("Debug mode off. Sending bark: "..TEXT)
		SendChatMessage(TEXT,'CHANNEL',nil,CHANNELID)
		
		if SK.db.profile.BARKER.NOTIFY_ON_BARK_SENT == true then --Does the user want me to print to the chat frame when I bark?
			
			D("User wants notification of bark.")
			SK:Print("Bark sent to channel "..CHANNELID.."!")

		end --End notification check.
		
		if SK.db.profile.BARKER.PLAY_SOUND_ON_BARK_SENT == true then --Does the user want me to sing a song when I bark?
			
			D("User wants sound played when bark sent.")
			--play sound
			
		end --End play sound check.
		
	end --End barker debug mode check.
	
	D("End SendBark.")

end --End SendBark.